INCLUDE \masm32\include\masm32rt.inc
.586
.xmm
INCLUDE \masm32\macros\timers.asm

.data
buffer BYTE "This is a test string for timing two string length algorithms", 0

.code
;  
;----------------------------------------------------------
;----------------------------------------------------------
ALIGN 16
StrLength PROC USES esi, buf:DWORD
	mov esi, buf
	test esi, 3
	jz IsAligned
	cmp BYTE PTR [esi], NULL
	je done
	add esi, 1
	test esi, 3
	jz IsAligned
	cmp BYTE PTR [esi], NULL
	je done
	add esi, 1
	test esi, 3
	jz IsAligned
	cmp BYTE PTR [esi], NULL
	je done
	add esi, 1
IsAligned:
	sub esi, 32
lbl1:
	add esi, 32
lbl2:
	mov eax, [esi]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jnz MightBeZero0

	mov eax, [esi+4]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jnz MightBeZero4

	mov eax, [esi+8]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jnz MightBeZero8

	mov eax, [esi+12]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jnz MightBeZero12

	mov eax, [esi+16]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jnz MightBeZero16

	mov eax, [esi+20]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jnz MightBeZero20

	mov eax, [esi+24]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jnz MightBeZero24

	mov eax, [esi+28]
	and eax, 7F7F7F7Fh
	sub eax, 01010101h
	and eax, 80808080h
	jz lbl1

	add esi, 28
	jmp MightBeZero0
MightBeZero4:
	add esi, 4
	jmp MightBeZero0
MightBeZero8:
	add esi, 8
	jmp MightBeZero0
MightBeZero12:
	add esi, 12
	jmp MightBeZero0
MightBeZero16:
	add esi, 16
	jmp MightBeZero0
MightBeZero20:
	add esi, 20
	jmp MightBeZero0
MightBeZero24:
	add esi, 24
MightBeZero0:
	mov eax, [esi]
	cmp al, 0
	je done
	cmp ah, 0
	je done1
	test eax, 0FF0000h
	je done2
	test eax, 0FF000000h
	je done3

	add esi, 4
	jmp lbl2
done3:
	sub esi, buf
	lea eax, [esi+3]
	jmp @F
done2:
	sub esi, buf
	lea eax, [esi+2]
	jmp @F
done1:
	sub esi, buf
	lea eax, [esi+1]
	jmp @F
done:
	mov eax, esi
	sub eax, buf
@@:
	ret
StrLength ENDP

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 
align 16
StrLenLingo	proc	lpszStr:DWORD
			mov		edx, esp
			mov		esp, [esp+1*4]
			pop		eax 	
@@Loop:						
			sub    	eax, 1010101h	
			pop		ecx	
			sub		ecx, 1010101h	
			test	eax, 80808080h	
			pop		eax
			jne		@f
@@LoopCont:				 		
			test	ecx, 80808080h
			je		@@Loop 	
			test    byte ptr [esp-8], 0FFh     
			je      mi8        
			test    byte ptr [esp-7], 0FFh
			je      mi7          
			test    byte ptr [esp-6], 0FFh
			je      mi6          
			test    byte ptr [esp-5], 0FFh
			jne     @@Loop
			lea		eax, [esp-5]
			mov		esp, edx
			sub		eax, [edx+1*4]
			ret		4
align 8
@@:
			test    byte ptr [esp-12], 0FFh     
			jz      mi12         
			test    byte ptr [esp-11], 0FFh
			jz      mi11          
			test    byte ptr [esp-10], 0FFh
			jz      mi10          
			test    byte ptr [esp-9], 0FFh
			jnz     @@LoopCont 
			lea		eax, [esp-9]
			mov		esp, edx
			sub		eax,[edx+1*4]
			ret		4
mi8:
            lea		eax, [esp-8]
	        mov		esp, edx
            sub		eax,[edx+1*4]
			ret		4
mi7: 
	        lea		eax, [esp-7]
	        mov		esp, edx
            sub		eax,[edx+1*4]
			ret		4
mi6:    
            lea		eax, [esp-6]
	        mov		esp, edx
            sub		eax,[edx+1*4]  
			ret		4
mi12:   
            lea		eax, [esp-12]
	        mov		esp, edx
            sub		eax,[edx+1*4]
		    ret		4
mi11: 
            lea		eax, [esp-11]
	        mov		esp, edx
            sub		eax,[edx+1*4]
			ret		4
mi10:    
            lea		eax, [esp-10]
	        mov		esp, edx
            sub		eax,[edx+1*4]  
			ret		4
StrLenLingo	endp
OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef

;----------------------------------------------------------
main PROC
	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE StrLen, ADDR buffer
	counter_end
	print ustr$(eax)
	print chr$(" cycles for agner fog StrLen-masmlib",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE StrLength, ADDR buffer
	counter_end
	print ustr$(eax)
	print chr$(" cycles for StrLength",13,10)

	counter_begin 10000000, HIGH_PRIORITY_CLASS
		INVOKE StrLenLingo, ADDR buffer
	counter_end
	print ustr$(eax)
	print chr$(" cycles for StrLenLingo",13,10)

	inkey "--test finished--"
	exit
main ENDP
END main


